<?php
# Original by Ryan Hadley
# http://blog.indigio.com/index.php/2008/01/23/goodbye-outlook/
#
# Ammendments by Simon McCartney (all-day event support, OWA links)

error_reporting(E_ALL ^ E_NOTICE);

require_once("class_http.php");
require_once("class_xml.php");

$exchange_server = "http://exchange_server";
$exchange_public = "https://public_OWA";
$exchange_username = $_SERVER["PHP_AUTH_USER"];
$exchange_password = $_SERVER["PHP_AUTH_PW"];

$h = new http();

$h->headers["Content-Type"] = 'text/xml; charset="UTF-8"';

$h->headers["Depth"] = "0";
$h->headers["Translate"] = "f";
$h->xmlrequest = '<?xml version="1.0"?>';
$h->xmlrequest .= <<<END
<g:searchrequest xmlns:g="DAV:">
        <g:sql> Select "urn:schemas:calendar:location", "urn:schemas:httpmail:subject",
                "urn:schemas:calendar:dtstart", "urn:schemas:calendar:dtend",
                "urn:schemas:calendar:busystatus", "urn:schemas:calendar:instancetype"
                FROM Scope('SHALLOW TRAVERSAL OF "/exchange/$exchange_username/calendar/"')
                WHERE NOT "urn:schemas:calendar:instancetype" = 1
                AND "DAV:contentclass" = 'urn:content-classes:appointment'
                AND "urn:schemas:calendar:dtstart" > '2007/06/01 00:00:00'
                ORDER BY "urn:schemas:calendar:dtstart" ASC
         </g:sql>
</g:searchrequest>
END;

if (!$h->fetch($exchange_server."/Exchange/$exchange_username/calendar", 0, null,
		$exchange_username, $exchange_password, "SEARCH")) {
  exit();
}

$x = new xml();
if (!$x->fetch($h->body)) {
    exit();
}

function format_time($date_string)
{
	# Date comes in like this: 2007-06-11T14:00:00.000Z
	# Need to go out something like this: 20070601T100000Z

	$date = str_replace("-", "", $date_string);
	$date = str_replace(".000Z", "Z", $date);
	$date = str_replace(":", "", $date);

	return $date;
}

function get_ex_ical_items( $url, $u, $p )
{
	$r = "";
	if( preg_match( "/http:/", $url ) ){
		$ch = curl_init( $url );
		curl_setopt( $ch, CURLOPT_HTTPHEADER, Array( "Translate: f\n" ) );
		curl_setopt( $ch, CURLOPT_USERPWD, "$u:$p" );
		ob_start();
		curl_exec( $ch );
		$tmp = ob_get_contents();
		ob_end_clean();
		curl_close( $ch );
		$ch = "";
		$lines = preg_split( "/\n/", $tmp, -1 );
		$go = 0;

		foreach ($lines as $line){
			$line = preg_replace( "/[\r\n]/", "", $line );
			if( preg_match( "/^ATTENDEE/", $line ) ||
			    preg_match( "/^ORGANIZER/", $line )||
			    preg_match( "/^LOCATION/", $line ) ||
			    preg_match( "/^DESCRIPTION/", $line ) ){
				if( strlen($r)>0 && !preg_match( "/[\r\n]$/", $r ) ){ $r .= "\n"; }
				$r .= "$line";
				$go = 1;
			} else if( preg_match( "/^ /", $line ) && $go==1 ){
				$r .= substr( $line, 1 );
			} else if( $go==1 ){
				$go = 0;
			}
		}
	}
	if( !preg_match( "/[\r\n]$/", $r ) ){
		$r .= "\n";
	}

	return( $r );
}


header("Content-Type: text/x-vCalendar");
header("Content-Disposition: inline; filename=mycal.ics");

echo "BEGIN:VCALENDAR\n";
echo "VERSION:2.0\n";

foreach($x->data->A_MULTISTATUS[0]->A_RESPONSE as $num => $event)
{
	# Date comes in like this: 2007-06-11T14:00:00.000Z

	# However, if this is an all-day event, we need to make sure
  	# something like this goes back to the client
	# DTSTART;VALUE=DATE:20070917
	# DTEND;VALUE=DATE:20080914
	#
	# all-day events look like this: 2007-06-11T23:00:00.000Z

	$allday = 'T23:00:00.000Z';
	if ( strpos($event->A_PROPSTAT[0]->A_PROP[0]->D_DTSTART[0]->_text, $allday) &&
	     strpos($event->A_PROPSTAT[0]->A_PROP[0]->D_DTEND[0]->_text, $allday))
	{
		# Weve got a all-day event
		$dtstart = str_replace("T23:00:00.000Z", "", $dtstart);
		$dtend = str_replace("T23:00:00.000Z", "", $dtend);

		$START = ";VALUE=DATE:" . str_replace("-", "", $dtstart);
		$END = ";VALUE=DATE:" . str_replace("-", "", $dtend);
	}
	else
	{
		$START = ":" . format_time($event->A_PROPSTAT[0]->A_PROP[0]->D_DTSTART[0]->_text);
		$END = ":" . format_time($event->A_PROPSTAT[0]->A_PROP[0]->D_DTEND[0]->_text);
	}


	$SUBJECT = $event->A_PROPSTAT[0]->A_PROP[0]->E_SUBJECT[0]->_text;
	$LOCATION = $event->A_PROPSTAT[0]->A_PROP[0]->D_LOCATION[0]->_text;

 	# $FIELDS = get_ex_ical_items( $event->A_HREF[0]->_text, $exchange_username, $exchange_password );

	$URL = str_replace($exchange_server, $exchange_public, $event->A_HREF[0]->_text);

	echo "BEGIN:VEVENT\n";
	echo "DTSTART$START\n";
	echo "DTEND$END\n";
	echo "URL:$URL\n";
	echo "SUMMARY:$SUBJECT\n";
	#echo "$FIELDS";
	echo "DESCRIPTION:$SUBJECT\n";
	echo "LOCATION:$LOCATION\n";
        if(gmdate("Ymd\THis\Z") < $START) {
                echo "BEGIN:VALARM\n";
                echo "ACTION:DISPLAY\n";
                echo "DESCRIPTION:$SUBJECT\n";
                echo "TRIGGER:-PT15M\n";
                echo "END:VALARM\n";
        }
	echo "END:VEVENT\n";
	echo "\n";
}
echo "END:VCALENDAR";
?>
